(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: NASLOVA.PAS                                                    *)
(*  Obsah: program pro prevod longintu na slovni vyjadreni                 *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 13.5.2010                                             *)
(*  Pro kompilaci: nic                                                     *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program Prevod_cisel_na_slova;

const NazvyDesitek:array[2..9] of string[9]=('dvacet','tricet','ctyricet','padesat','sedesat',
                                             'sedmdesat','osmdesat','devadesat');
      NazvyJednotek:array[1..19] of string[10]=('jedna','dva','tri','ctyri','pet','sest','sedm','osm',
                                                'devet','deset','jedenact','dvanact','trinact','ctrnact',
                                                'patnact','sestnact','sedmnact','osmnact','devatenact');

function NaSlova(cislo:longint):string; {funkce pro prevedeni cisla na slova}
{}function TriCifry(cislo:word):string;{pomocna, pro prevod cisla v rozsahu 1..999}
{}var vystup:string;
{}    horni:byte;
{}Begin
{}horni:=cislo div 100; {stovky}
{}cislo:=cislo mod 100;
{}case horni of 1:vystup:='sto';
{}              2:vystup:='dve ste';
{}              3,4:vystup:=nazvyjednotek[horni]+' sta';
{}              5..9:vystup:=nazvyjednotek[horni]+' set';
{}              else vystup:='';
{}              end;
{}if cislo<>0 then begin {pod stovkami zbyva jeste neco mensiho}
{}                 if horni<>0 then vystup:=vystup+' ';
{}                 if cislo>=20 then begin
{}                                   horni:=cislo div 10; {desitky}
{}                                   cislo:=cislo mod 10;
{}                                   vystup:=vystup+nazvydesitek[horni];
{}                                   if cislo<>0 then vystup:=vystup+' ';
{}                                   end;
{}                 vystup:=vystup+nazvyjednotek[cislo];
{}                 end;
{}tricifry:=vystup;
{}End;{tricifry}
var miliardy:byte;
    miliony,tisice:word;
    vystup:string;
Begin {naslova}
if cislo=0 then begin
                naslova:='nula';
                exit;
                end;
if cislo<0 then begin
                vystup:='minus ';
                cislo:=-cislo;
                end
           else vystup:='';
miliardy:=cislo div 1000000000;
cislo:=cislo mod 1000000000;
miliony:=cislo div 1000000;
cislo:=cislo mod 1000000;
tisice:=cislo div 1000;
cislo:=cislo mod 1000;
{miliardy:}
if miliardy=1 then vystup:=vystup+'miliarda'
 else if miliardy=2 then vystup:=vystup+'dve miliardy';
  {vzhledem k rozsahu longintu muzou byt miliardy maximalne 2, tak nic vetsiho nemusime resit}
if (miliardy<>0)and(miliony+tisice+cislo<>0) then vystup:=vystup+' ';
{miliony:}
if miliony<>0 then begin
                   if miliony=1 then vystup:=vystup+'milion'
                    else if (miliony>=2)and(miliony<=4) then vystup:=vystup+nazvyjednotek[miliony]+' miliony'
                     else vystup:=vystup+tricifry(miliony)+' milionu';
                   if tisice+cislo<>0 then vystup:=vystup+' ';
                   end;
{tisice:}
if tisice<>0 then begin
                  if tisice=1 then vystup:=vystup+'tisic'
                   else if (tisice>=2)and(tisice<=4) then vystup:=vystup+nazvyjednotek[tisice]+' tisice'
                    else vystup:=vystup+tricifry(tisice)+' tisic';
                  if cislo<>0 then vystup:=vystup+' ';
                  end;
{zbytek:}
if cislo<>0 then vystup:=vystup+tricifry(cislo);
naslova:=vystup;
End;{naslova}

{---------------------------------------------}
 
var cislo:longint;
    odpoved:char;

BEGIN
writeln(' Program pro vyjadreni cisel slovy');
writeln('===================================');
writeln('       (c) Mircosoft 2010');
writeln;
 repeat
 write('Zadejte cele cislo (longint): '); readln(cislo);
 writeln(cislo,' = ',naslova(cislo));
 write('Dalsi? (A/N) '); readln(odpoved);
 until upcase(odpoved)<>'A';
END.
